'DERIVATA


;FUNZIONI PREDEFINITE

(define fx '(2 * (x + (ln 5 ))))
(define gx '((( x ** 2) + ((x + 2) / (ln 5))) * ( 3 * x )) )


'FUNZIONE

(define (deriva esp var)
        (cond ((costante? esp) 0)

              ((variabile? esp)
                 (if (stessa-variabile? esp var) 1 0))

              ((addizione? esp)
                (crea-somma (deriva (addendo1 esp) var)
                            (deriva (addendo2 esp) var)))

              ((sottrazione? esp)
                (crea-differenza (deriva (minuendo esp) var)
                                 (deriva (sottraendo esp) var)))

              ((moltiplicazione? esp)
                (crea-somma 
                    (crea-prodotto (fattore1 esp)
                                   (deriva (fattore2 esp) var))
                    (crea-prodotto (deriva (fattore1 esp) var)
                                   (fattore2 esp))))
              
              ((divisione? esp)
                 (crea-quoziente
                     (crea-differenza
                         (crea-prodotto (deriva (numeratore esp) var)
                                        (denominatore esp))
                         (crea-prodotto (numeratore esp)
                                        (deriva (denominatore esp) var)))
                     (crea-potenza (denominatore esp) 2)))
                                   
              ((potenza? esp)
                (crea-prodotto
                    (crea-prodotto(esponente esp) 
                        (crea-potenza (base esp)(-1+ (esponente esp))))
                    (deriva (base esp) var)))
              
              ((logaritmo? esp)
                (crea-logaritmo (deriva (arg esp) var)        
                                (arg esp)))))

'PREDICATI

(define (costante? x) (number? x))

(define (variabile? x) (symbol? x))

(define (stessa-variabile? v1 v2)
        (and (variabile? v1) (variabile? v2) (eq? v1 v2)))

(define (addizione? x)
        (if (not (atom? x)) (eq? (cadr x) '+) nil))

(define (sottrazione? x)
        (if (not (atom? x)) (eq? (cadr x) '-) nil))

(define (moltiplicazione? x)
        (if (not (atom? x)) (eq? (cadr x) '*) nil))

(define (divisione? x)
        (if (not (atom? x)) (eq? (cadr x) '/) nil))

(define (potenza? x)
        (if (not (atom? x)) (eq? (cadr x) '**) nil))

(define (logaritmo? a)
        (if (not (atom? a)) (eq? (car a) 'ln) nil))

'COSTRUTTORI

(define (crea-somma a1 a2) 
        (cond ((and (number? a1) (number? a2)) (+ a1 a2))
              ((number? a1) (if (= a1 0) a2 (list a1 '+  a2)))
              ((number? a2) (if (= a2 0) a1 (list a1 '+ a2)))
              ((stessa-variabile? a1 a2) (list '2 '* a1))
              (else (list a1 '+ a2))))
  
(define (crea-differenza a1 a2) 
        (cond ((and (number? a1) (number? a2)) (- a1 a2))              
              ((eq? a1 0) (list '- a2)) 
              ((number? a2) (if (= a2 0) a1 (list a1 '- a2)))
              ((stessa-variabile? a1 a2) 0)
              (else (list a1 '- a2))))


(define (crea-prodotto m1 m2) 
        (cond ((and (number? m1) (number? m2)) (* m1 m2))
              ((number? m1)
                 (cond ((= m1 0) 0)
                       ((= m1 1) m2)
                       (else (list m1 '* m2))))
              ((number? m2)
                 (cond ((= m2 0) 0)
                       ((= m2 1) m1)
                       (else (list m2 '* m1))))
              (else (list m1 '* m2))))

(define (crea-quoziente q1 q2)
        (cond ((and (number? q1) 
                    (number? q2))  (let* ((a (gcd q1 q2))
                                         (n (/q1 a))
                                         (d (/q2 a))) 
                                         (if  (rational? (/ n d))
                                                        (list n '/ d)
                                                        (/ n d)))) 
              ((eq? q1 0) 0)
              ((eq? q1 q2) 1)
              ((eq? q2 0) (error "divisione per zero"))
              ((eq? q2 1) q1)
              (else (list q1 '/ q2))))
              

(define (crea-potenza p1 p2)
        (cond ((and (number? p1) (number? p2)) (expt p1 p2))
              ((= p2 0) 1)
              ((= p2 1) p1) 
              (else (list p1 '** p2))))

(define (crea-logaritmo l1 l2)
        (cond ((eq? l1 0) 0)
              (else (list l1 '/ l2))))
 
'SELETTORI

(define (addendo1 s) (car s))

(define (addendo2 s) (caddr s))

(define (minuendo s) (car s))

(define (sottraendo s) (caddr s))

(define (fattore1 p) (car p))

(define (fattore2 p) (caddr p))

(define (numeratore p) (car p))

(define (denominatore p) (caddr p))

(define (base pp) (car pp))

(define (esponente pp) (if (number? (caddr pp))
                           (caddr pp)
                           (error "L'esponente deve essere un numero")))

(define (arg k) (cadr k))
                                
