
(define in1 (list 'set 1 3 5 6 -7))
(define in2 (list 'set 2 12 41 1 7))
(define in3 (list 'set '(set 3 4 5) '(set 5 6 7) '(set 12 4 5 3 1)))
(define in4 (list 'set '(set 3 4 5) '(2 3 4) '(set 5 6 7) '(set 12 4 5 3 1)))

'INSIEME


'PREDICATI

(define (empty-set? s) (null? (cdr s)))

(define (set? s)
    (cond ((atom? s) #f)
	  ((eq? (car s) 'set) #t)
	  (else ())))

(define (element-of-set? x set)
	(define found #f)
	(while (and (not found)
		    (not (null? set)))
	       (if (eqv? x (car set))
		   (set! found #t)
		   (set! set (cdr set))))
	found)

(define (element-of-list? x set)
	(define found #f)
	(while (and (not found)
		    (not (null? set)))
	       (if (eqv? x (car set))
		   (set! found #t)
		   (set! set (cdr set))))
	found)

'SELETTORI



(define (pick s)
   (do ((posizione (random (-1+ (length s))) (- posizione 1  ))
	(element (cdr s) (cdr element)))
       ((= posizione 0) (car element))))

(define (resto! obj s)
    (do ((move (cdr s) (cdr move))
	 (last s (cdr last)))
	((null? move) s)
	(if (eq? (car move) obj)
	    (set-cdr! last (cdr move)))))

'COSTRUTTORI

(define empty-set (list 'set))


(define (adjoin! x set)
	(if (element-of-set? x set)
	    set
	    (begin (set-cdr! set (cons x (cdr set)))
		   set)))

(define (insieme->lista s)
	(if (set? s)
	(cdr s)
	()))


'---------------------------------------------------------------------------
'----------------------------OPERAZIONI-------------------------------------
'---------------------------------------------------------------------------

(define (element obj s)
  (cond ((empty-set?  s ) () )
	((eq? obj (car s)) #t)
	(else (element obj (cdr s)))))

(define (make-set! . l) (append empty-set l))


(define (superset? s1 s2)
	(let ((elem (pick s2))
	      (exit #t)
	      (ris #t))
	     (while exit
		    (cond ((empty-set? s2) (set! exit #f))
			  ((not (element-of-set? elem s1))
					     (begin (set! exit #f)
						    (set! ris #f)))
			  (else (begin (resto! elem s2)
				       (set! elem (pick s2))))))
	      ris))


(define (cardinality s)
   (let ((pset (copy s))
	 (elem (pick s))
	 (n 0))
	(while (not (empty-set? pset))
	       (set! pset (resto! elem pset))
	       (set! elem (pick pset))
	       (set! n (1+ n)))
    n))

(define (intersection! set1 set2)
	(let ((int-set (copy empty-set))
	      (pset (copy set1))
	      (elem (pick set1)))
	 (while (not (empty-set? pset))
	     (when (element-of-set? elem set2)
		   (adjoin! elem int-set))
	     (set! pset (resto! elem pset))
	     (set! elem (pick pset)))
	 (set-cdr! set1 (cdr int-set)))
	 set1)

(define (union! set1 set2)
	(let ((elem (pick set2)))
	(while (not (empty-set? set2))
	       (adjoin! elem set1)
	       (set! set2 (resto! elem set2))
	       (set! elem (pick set2)))
	set1))

(define (difference! set1 set2)
	(let ((elem (pick set2)))
	 (while (not (empty-set? set2))
	     (when (element-of-set? elem set1)
		   (resto! elem set1))
	     (set! set2 (resto! elem set2))
	     (set! elem (pick set2)))
	 set1))

(define (prod-cart! s1 s2)
	(let ((elem1 (pick s1))
	      (pc (copy empty-set)))
	     (while (not (empty-set? s1))
		    (let ((s3 (copy s2))
			  (elem2 (pick s2)))
			 (while (not (empty-set? s3))
				(adjoin! (cons elem1 elem2) pc)
				(set! s3 (resto! elem2 s3))
				(set! elem2 (pick s3)))
			 (set! s1 (resto! elem1 s1))
			 (set! elem1 (pick s1))))
	      (set-cdr! s1 (cdr pc))
	      pc))

(define (union-gen s2)
	(let* ((ug empty-set)
	      (s1 (copy s2))
	      (ins (pick s1)))
	     (while (not (empty-set? s1))
		    (union! ug ins)
		    (set! s1 (resto! ins s1))
		    (set! ins (pick s1)))
	     ug))

(define (inters-gen s2)
	(let* ((s1 (copy s2))
	       (ig (pick s1))
	       (ins (pick s1)))
	     (while (not (empty-set? s1))
		    (intersection! ig ins)
		    (set! s1 (resto! ins s1))
		    (set! ins (pick s1)))
	     ig))

(define (power-set! ins)
      (let* ((l (insieme->lista ins))
	     (n (length l))
	     (pos 0)
	     (parz (copy empty-set))
	     (tot (copy empty-set))
	     (max (-1+ (expt 2 n)))
	     (max2 (copy max)))
	    (while (< -1 max)
		 (while (< pos n)
		      (if (= (remainder max2 2) 1)
			  (begin (adjoin! (list-ref l pos) parz)
				 (set! max2 (/ (-1+ max2) 2)))
			  (set! max2 (/ max2 2)))
			(set! pos (1+ pos)))
		 (set! pos 0)
		 (adjoin! parz tot)
		 (set! parz (copy empty-set))
		 (set! max (-1+ max))
		 (set! max2 (copy max)))
	       tot))


(define (for-all o ins)
	(not (element-of-list? () (map o (insieme->lista ins)))))

(define (exist o ins)
	(element-of-list? #t (map o (insieme->lista ins))))

(define (none o ins)
	(element-of-list? () (map o (insieme->lista ins))))

